using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using INT_LKD_2.DataStore;

namespace INT_LKD_2.DialogForms
{
    public partial class DialogFormPasswordKeyPad : Form
    {
        #region Field
        private string m_InputKey;
        private string m_PasswordDeveloper;
        private string m_PasswordHiddenMenu;

        private int m_Digit;
        private int m_DecPoint;
        #endregion

        #region Constructor
        public DialogFormPasswordKeyPad(int digit, Define.E_LanguageID language)
        {
            InitializeComponent();

            this.Digit = digit;
            this.PasswordDeveloper = "0714";
            this.PasswordHiddenMenu = DateTime.Now.ToString("MMdd") + "0810";

            this.InitializeDesign(language);
        }
        #endregion

        #region Property
        private string InputKey
        {
            get { return this.m_InputKey; }
            set { this.m_InputKey = value; }
        }
        public string PasswordDeveloper
        {
            get { return this.m_PasswordDeveloper; }
            set { this.m_PasswordDeveloper = value; }
        }
        public string PasswordHiddenMenu
        {
            get { return this.m_PasswordHiddenMenu; }
            set { this.m_PasswordHiddenMenu = value; }
        } 

        private int Digit
        {
            get { return this.m_Digit; }
            set { this.m_Digit = value; }
        }
        private int DecPoint
        {
            get { return this.m_DecPoint; }
            set { this.m_DecPoint = value; }
        }
        #endregion

        #region Method
        private void InputNum(string key)
        {
            if (this.InputKey.Length >= this.Digit)
            {
                this.InputKey = key;
                this.labelScreen.Text = "*";
            }
            else
            {
                this.InputKey += key;
                this.labelScreen.Text += "*";
            }
        }

        private void InitializeDesign(Define.E_LanguageID language)
        {
            if (language == Define.E_LanguageID.English)
            {
                this.buttonCancel.Text = "ESC";
                this.buttonEnter.Text = "Enter";
            }
            else
            {
                this.buttonCancel.Text = "ESC";
                this.buttonEnter.Text = "Enter";
            }
        }
        private void InitializeControl()
        {
            int x = 0, y = 0;

            x = Screen.PrimaryScreen.Bounds.Width / 2 - this.Size.Width / 2;
            y = Screen.PrimaryScreen.Bounds.Height / 2 - this.Size.Height / 2;

            this.Location = new Point(x, y);

            this.Size = new Size(250, 356);

            this.InputKey = "";
            this.labelScreen.Text = "";
        }
        #endregion

        #region Override Member
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.InitializeControl();
        }
        #endregion

        #region Event Handler
        private void buttonEnter_Click(object sender, EventArgs e)
        {
            if (this.labelScreen.Text.Length == 4)
            {
                if (this.Digit == 4)
                {
                    if (this.InputKey == this.PasswordDeveloper)
                    {
                        this.DialogResult = DialogResult.OK;
                    }
                }
            }
            else if (this.labelScreen.Text.Length == 8)
            {
                if (this.Digit == 8)
                {
                    if (this.InputKey == this.PasswordHiddenMenu)
                        this.DialogResult = DialogResult.OK;
                }
            }

            this.InputKey = "";
            this.labelScreen.Text = "";
        }

        private void buttonNumber_Click(object sender, EventArgs e)
        {
            Button bt = sender as Button;

            if (bt == null)
                return;

            if (bt == this.buttonNumber0)
                this.InputNum("0");
            else if (bt == this.buttonNumber1)
                this.InputNum("1");
            else if (bt == this.buttonNumber2)
                this.InputNum("2");
            else if (bt == this.buttonNumber3)
                this.InputNum("3");
            else if (bt == this.buttonNumber4)
                this.InputNum("4");
            else if (bt == this.buttonNumber5)
                this.InputNum("5");
            else if (bt == this.buttonNumber6)
                this.InputNum("6");
            else if (bt == this.buttonNumber7)
                this.InputNum("7");
            else if (bt == this.buttonNumber8)
                this.InputNum("8");
            else if (bt == this.buttonNumber9)
                this.InputNum("9");
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        #endregion
    }
}